{% extends 'dashboard/dashboard_content.html' %}

{% block title %}
    Timetable Lookups
{% endblock %}

{% block rightPane %}
    {% if perms.curriculum.can_view_my_timetable %}
        <div class="row" xmlns="http://www.w3.org/1999/html">
            <div class="x_panel">
                <div class="x_title">
                    <h2>
                        <i class="icomoon icon-calendar"></i> Timetable Lookups
                    </h2>
                    <div class="clearfix"></div>
                </div>
                <div class="row">
                    <div class="col-md-12 col-sm-12 col-xs-12">
                        <form id="submit_form" class="form-horizontal form-label-left" method="POST">{% csrf_token %}

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Department
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <select name="department" id="department" class="form-control"
                                            required>
                                        <option disabled selected>-----------</option>
                                        {% for each in department_list %}
                                            <option value="{{ each.id }}">{{ each.acronym }}</option>
                                        {% endfor %}
                                    </select>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Batch
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <select name="batch" id="batch" class="form-control"
                                            required>
                                        <option disabled selected>-----------</option>
                                    </select>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Semester
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <select name="semester" id="semester" class="form-control"
                                            required>
                                        <option disabled selected>-----------</option>
                                    </select>
                                </div>
                            </div>

                            <br>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <button type="submit" class="btn1 btn-blue-grey1">Fetch Timetable
                                    </button>
                                </div>
                            </div>

                        </form>
                    </div>
                </div>
                {% if no_timetable %}
                    <br><br>
                    <div role="alert" class="alert alert-warning alert-dismissible fade in">
                        <h4 align="center"> No Timetable found for <strong>{{ batch_instance }}</strong> in
                            semester <strong>{{ semester_number }}</strong></h4>
                    </div>

                {% endif %}
                {% if list_of_hours %}
                    <div role="alert" class="alert alert-success alert-dismissible fade in">
                        <h4 align="center"> This is the timetable of batch <strong>{{ batch_instance }}</strong> in
                            semester <strong>{{ semester_number }}</strong></h4>
                    </div>

                    {% if no_faculty_advisor %}
                        <div role="alert" class="alert alert-warning alert-dismissible fade in">
                            <h5> Timetable not created. Contact your Programme Coordinator for futher details. </h5>
                        </div>
                    {% else %}
                        <div class="alert alert-info alert-dismissible fade in" role="alert" align="center">
                            <h5> Faculty Advisors:&nbsp;
                                <strong>
                                    {% for faculty in faculty_advisors %}
                                        {{ faculty }}&nbsp;&nbsp;
                                    {% endfor %}
                                </strong>
                            </h5>
                        </div>

                        <div class="table-responsive">
                            <table class="table table-bordered col-md-12 col-sm-12 col-xs-12">
                                <thead>
                                <tr>
                                    <th>#</th>
                                    <th>1st hour</th>
                                    <th>2nd hour</th>
                                    <th>3rd hour</th>
                                    <th>4th hour</th>
                                    <th>5th hour</th>
                                    <th>6th hour</th>
                                    <th>7th hour</th>
                                    <th>8th hour</th>
                                </tr>
                                </thead>
                                <tbody>
                                {% for day in list_of_hours %}
                                    <tr>
                                        <th>{{ day.day_name }}</th>
                                        {% for hour in day.hours %}
                                            <td align="center">
                                                {% if not hour %}
                                                    -
                                                {% else %}
                                                    {% for course in hour %}
                                                        {{ course }}<br>
                                                    {% endfor %}
                                                {% endif %}
                                            </td>
                                        {% endfor %}
                                    </tr>
                                {% endfor %}
                                </tbody>
                            </table>
                        </div>
                        <br><br>
                        <table class="table table-hover">
                            <thead>
                            <tr>
                                <th>Course Code</th>
                                <th>Course Name</th>
                                <th>Staff Handling</th>
                            </tr>
                            </thead>
                            <tbody>
                            {% for course in list_of_courses %}
                                <tr>
                                    <td>{{ course.course_id }}</td>
                                    <td>
                                        {{ course.course_name }}&nbsp;
                                        {% if course.code %}
                                            ({{ course.code }})
                                        {% endif %}
                                    </td>
                                    <td>
                                        {% for staff in course.staff_list %}
                                            {{ staff }}&nbsp;&nbsp;
                                        {% endfor %}
                                    </td>
                                </tr>
                            {% endfor %}
                            </tbody>
                        </table>
                    {% endif %}
                {% endif %}
            </div>
        </div>
    {% endif %}

    <form id="dummy_form" method="POST">
        {% csrf_token %}
    </form>

    <script type="text/javascript">

        //For getting CSRF token
        function getCookie(name) {
            var cookieValue = null;
            if (document.cookie && document.cookie != '') {
                var cookies = document.cookie.split(';');
                for (var i = 0; i < cookies.length; i++) {
                    var cookie = jQuery.trim(cookies[i]);
                    // Does this cookie string begin with the name we want?
                    if (cookie.substring(0, name.length + 1) == (name + '=')) {
                        cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                        break;
                    }
                }
            }
            return cookieValue;
        }

        $(document).on("change", '#department', function (e) {
            $('#batch').empty();
            $('#batch').append('<option disabled selected>' + '-----------' + '</option>');
            {% for each in batch_list %}
                $('#batch').append('<option value="{{ each.id }}">{{ each }}</option>');
            {% endfor %}
        });

        $(document).on("change", '#batch', function (e) {
            var batch = $(this).val();
            var department = $('#department').val();
            //alert(batch);

            $.ajax({
                type: "POST",
                data: {
                    batch: batch,
                    department: department,
                    csrfmiddlewaretoken: getCookie('csrftoken')
                },
                url: '{% url 'view_previous_timetable' %}',
                success: function (data) {
                    available_semesters = data.available_semesters;
                    if (available_semesters.length == 0) {
                        alert('No semester plan available');
                    }
                    $('#semester').empty();
                    $('#semester').append('<option disabled selected>' + '-----------' + '</option>');
                    var i;
                    var temp;
                    for (i = 0; (temp = available_semesters[i]); i++) {
                        $('#semester').append('<option value="' + temp['semester_pk'] + '">' + temp['semester_display_text'] + '</option>');
                    }
                }
            });

        });

        $(document).on("submit", '#submit_form', function (e) {

            e.preventDefault();

            var department = $('#department').val();
            var batch = $('#batch').val();
            var semester = $('#semester').val();

            if (department == null) {
                alert('Select Department!');
                return;
            }

            if (batch == null) {
                alert('Select Batch!');
                return;
            }

            if (semester == null) {
                alert('Select Semester!');
                return;
            }

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: getCookie('csrftoken'),
                name: 'csrfmiddlewaretoken'
            });
            $hiddenInput.appendTo('form');

            var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#batch').val(), name: 'batch_id'});
            $hiddenInput.appendTo('form');

            var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#department').val(), name: 'department'});
            $hiddenInput.appendTo('form');

            var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#semester').val(), name: 'semester_pk'});
            $hiddenInput.appendTo('form');

            $('#dummy_form').submit();

        });

    </script>

{% endblock %}